program BNFill
  use sep
  use bnhelix
  use bcreatenhelixmod
  use bnsfill

  implicit none
  integer                             :: n123, is, ns, dim, i, niter, nf, nbf, nbp, np123, ip, id, hrd, hel
  integer, dimension (:), allocatable :: n, a, center, gap, jump, lag, pch, nh, ipp, np, npa, ii, cd, pp
  real,    dimension (:),    pointer  :: dd, kk
  real,    dimension (:), allocatable :: npd, model
  real,    dimension(:,:), allocatable :: coefs
  logical, dimension (:), allocatable :: k0
  type(bnfilter)                       :: nsaa
  character (len = 6)                 :: varname
  real                                :: eps
  logical                             :: hard
  call sep_init (SOURCE)
  dim = sep_dimension ()
  allocate (n (dim), a (dim), center (dim), gap (dim), npa(dim), npd(dim), ii(dim),cd(dim), np(dim))
  call from_history (n); n123 = product (n)
  call to_history ("n",n)
  call from_aux ("pef","a", a)
  center=1; where (a (2:) > 1) center (:dim-1) = a (:dim-1)/2+1
  call from_aux ("pef","center", center, center)
  gap = 0
  call from_aux ("pef","gap", gap, gap)

  allocate (dd (n123), kk (n123), k0(n123), model(n123))
  call sep_read (dd)
  if (exist_file ("maskin")) then
     call sep_read (kk, "maskin")
  else
     kk = 1.
  end if
  k0=.false.
  where (kk==1)
     k0=.true.
  end where
  

! make patch table, or read patch table
  allocate (pp (n123), ipp(n123)) 
  np=0
  if (exist_file ("pch")) then
!     call sep_read (pp, "pch")
     call from_aux("pch","np",npd)
     np=int(n/int(npd))
     ipp=int(pp)
     np123 = maxval (pp)
  else
     pp=0
     npa=1
     call from_aux("pef","np",npa,npa)
     write(0,*)"npa",npa,n
     np=int(n/npa)
     write(0,*)"np",np,"n123",n123
     do ip=1,n123
        call line2cart(n,ip,ii)
        do id=1,dim
           cd(id)=int((ii(id)-1)/npa(id))+1
        end do 
        call cart2line(np,cd,hel)
        pp(ip)=hel
     end do
     ipp=int(pp)
     np123 = maxval(ipp)
  end if

  nsaa = bcreatenhelix( n, center, gap, a, pp)    ! allocate PEF
  deallocate (pp)
  call from_par( "niter", niter, 100 )
  call from_par ("epsilon", eps, 0.01)
  call sep_read(nsaa%flt,"pef")

  call bn_fill(dd, model, nsaa, k0, niter,eps)
  call sep_write(model)
  call sep_close ()
  call exit (0)
end program BNFill