program BNInterp
  use sep
  use bnhelix
  use bcreatenhelixmod
  use bnpef_find
  use bnsfill
  use bnpefsetup

  implicit none
  integer                             :: n123, is, ns, dim, i, niter, nf, nbf, nbp, np123, ip, id, hel, nh
  integer, dimension (:), allocatable :: n, a, center, gap, lag, pch, ipp, npa, ii, np, cd, pp
  real,    dimension (:),    pointer  :: dd, kk, resd, weight, model
  real,    dimension (:), allocatable :: npd
  logical, dimension (:), allocatable :: known,alltrue
  type(bnfilter)                      :: aa
  character (len = 6)                 :: varname
  character (len = 60)                :: residual
  real                                :: epsp, epsf, jump

  call sep_init (SOURCE)
  dim = sep_dimension ()
  allocate (n (dim), a (dim), center (dim), gap (dim), npa(dim), np(dim),npd(dim), ii(dim), cd(dim))
  call from_history (n); n123 = product (n)
  call to_history ("n",n)
  call from_param ("a", a)
  center=1; where (a (2:) > 1) center (:dim-1) = a (:dim-1)/2+1
  call from_param ("center", center, center)
  gap = 0
  call from_param ("gap", gap, gap)
  call from_param ("resd", residual, "dresid.H")

  allocate (dd (n123), kk (n123), known(n123),weight(n123),resd(n123),model(n123),alltrue(n123))
  call sep_read (dd)
  dd = dd / maxval (abs (dd))
!  call random_number (kk)
!  dd = dd + 100.*epsilon(kk)*(kk-0.5)

  if (exist_file ("mask")) then
     call sep_read (kk, "mask")
     where (kk>0.1)
        known=.true.
     elsewhere
        known=.false.
     end where
     alltrue=.true.
     write(0,*)"mask found: count",count(known),"of size",size(known)
  else
     known=.true.
  end if
  deallocate(kk)
  if (exist_file ("weight")) then
     call sep_read (weight, "weight")
  else
     weight = 1.
  end if

! make patch table, or read patch table
  allocate (pp (n123), ipp(n123)) 
np=0
  if (exist_file ("pch")) then
!     call sep_read (pp, "pch")
     call from_aux("pch","np",npd)
     np=int(n/int(npd))
     ipp=int(pp)
     np123 = maxval (pp)
  else
     pp=0
     npa=1
     call from_param("np",npa,npa)
     np=int(n/npa)
     do ip=1,n123
        call line2cart(n,ip,ii)
        do id=1,dim
           cd(id)=int((ii(id)-1)/npa(id))+1
        end do
        call cart2line(np,cd,hel)
        pp(ip)=hel
     end do
     np123 = maxval(pp)
  end if

  call from_param ("jump",jump)

  aa = bcreatenhelix( n, center, gap, a, pp)    ! allocate PEF
  nh=size(aa%lag)
  allocate(aa%mis(n123))
  deallocate (pp)
  call from_par( "niter", niter, 100 )
  call from_par ("epsilonp", epsp, 0.01)
  call from_par ("epsilonf", epsf, 0.01)
  nf=nh

  call setuppef(aa,jump,n,a,known)

write(0,*)"before estimate:"
write(0,*)"PEF dimensions, value- filter:",size(aa%flt,1),size(aa%flt,2),maxval(aa%flt)
write(0,*)"lag",aa%lag
write(0,*)"mis",size(aa%mis),count(aa%mis)
write(0,*)"pch",size(aa%pch),maxval(aa%pch)

  call find_pef ( dd, aa, niter, epsp,resd, weight, np)
  
  call setuppef(aa,1/jump,n,a,alltrue)
  write(0,*)"after estimate:"
write(0,*)"PEF dimensions, value- filter:",size(aa%flt,1),size(aa%flt,2),maxval(aa%flt)
write(0,*)"lag",aa%lag
write(0,*)"mis",size(aa%mis),count(aa%mis)
write(0,*)"pch",size(aa%pch),maxval(aa%pch)


write(0,*)"Before filling:"
write(0,*)"data size min max",size(dd),minval(dd),maxval(dd)
write(0,*)"known size count",size(known),count(known)
write(0,*)"model size min max",size(model),minval(model),maxval(model)
write(0,*)"niter, epsf",niter,epsf
  call bn_fill(dd, model, aa, known, niter, epsf)
  call sep_write(model)

  call to_history("n1",n(1),residual)
  call to_history("n2",n(2),residual)
  if (dim<3) then
  	call to_history("n3",1,residual)
  else
  	call to_history("n3",n(3),residual)
  end if
  if (dim<4) then
    call to_history("n4",1,residual)
  else
    call to_history("n4",n(4),residual)
  end if
  call sep_close ()
  call exit (0)
end program BNInterp
