program BNInterp_2d
  use sep
  use bnhelix
  use bcreatenhelixmod
  use bnpef_find
  use bnsfill
  use bnpefsetup

  implicit none
  integer                             :: n12, n123, is, ns, dim, i, niter, nf, nbf, nbp, np12, np123, ip, id, hel, nh, i3, nbytes
  integer, dimension (:), allocatable :: n, a, center, gap, lag, pch, ipp, npa, ii, np, cd, pp, nwin, jwin, fwin
  real,    dimension (:),    pointer  :: dd, kk, resd, weight, model
  real,    dimension (:), allocatable :: npd
  logical, dimension (:), allocatable :: known,alltrue
  type(bnfilter)                      :: aa
  character (len = 6)                 :: varname
  character (len = 60)                :: residual
  real                                :: epsp, epsf, jump

  call sep_init (SOURCE)
  write(0,*)"BNInterp3d 1"
  dim = sep_dimension ()
  write(0,*)"BNInterp3d 2"
  allocate (n (dim), a (2), center (2), gap (2), npa(2), np(2),npd(2), ii(2), cd(2),nwin(dim),jwin(dim),fwin(dim))
  call from_history (n); n123 = product (n); n12=n(1)*n(2); nwin=1; nwin(1:2)=n(1:2)
  write(0,*)"BNInterp3d 3"
  call to_history ("n",n)
  write(0,*)"BNInterp3d 4"
  call from_param ("a", a)
  write(0,*)"BNInterp3d 5"
  center=1; where (a (2:) > 1) center (:1) = a (:1)/2+1
  call from_param ("center", center, center)
  gap = 0
  write(0,*)"BNInterp3d 6"
  call from_param ("gap", gap, gap)
  call from_param ("resd", residual, "dresid.H")

  write(0,*)"BNInterp3d 7"
  allocate (dd (n12), kk (n12), known(n12),weight(n12),resd(n12),model(n12),alltrue(n12))
     alltrue=.true.
  write(0,*)"BNInterp3d 8"
! make patch table, or read patch table
  allocate (pp (n12), ipp(n12)) 
  write(0,*)"BNInterp3d 9"
np=0
  if (exist_file ("pch")) then
!     call sep_read (pp, "pch")
     call from_aux("pch","np",npd)
     np=int(n(1:2)/int(npd))
     ipp=int(pp)
     np12 = maxval (pp)
  else
     pp=0
     npa=1
     call from_param("np",npa,npa)
write(0,*)"npd",npa
     np=int(n(1:2)/npa)
     do ip=1,n12
        call line2cart(n(1:2),ip,ii)
        do id=1,2
           cd(id)=int((ii(id)-1)/npa(id))+1
        end do
        call cart2line(np,cd,hel)
        pp(ip)=hel
     end do
     np12 = maxval(pp)
  end if

  call from_param ("jump",jump)

  aa = bcreatenhelix( n(1:2), center, gap, a, pp)    ! allocate PEF
  aa%flt=0.
  nh=size(aa%lag)
  allocate(aa%mis(n12))
  deallocate (pp)
  call from_par( "niter", niter, 100 )
  call from_par ("epsilonp", epsp, 0.01)
  call from_par ("epsilonf", epsf, 0.01)
  nf=nh

  jwin=1
! put loop here
  fwin=0
  
       if (exist_file ("mask")) then
        call sep_read(kk,"mask")
!        call sreed("mask",dim,n,nwin,fwin,jwin,4,kk)
        where (kk>0.1)
           known=.true.
        elsewhere
           known=.false.
        end where
        write(0,*)"mask found: count",count(known),"of size",size(known)
     else
        known=.true.
     end if
     deallocate(kk)

  do i3=1,product(n(3:dim))
     fwin(3)=i3-1
 write(0,*)"nwin,fwin,jwin",nwin,fwin,jwin
     call sreed_window("in",dim,n,nwin,fwin,jwin,4,dd)
     write(0,*)"slice ",i3," of ",product(n(3:dim)),size(dd),maxval(dd),minval(dd)

 !  dd = dd / maxval (abs (dd))
!  call random_number (kk)
!  dd = dd + 100.*epsilon(kk)*(kk-0.5)
write(0,*)"before mask read",dim,n,nwin,fwin,jwin, size(kk)
     if (exist_file ("weight")) then
        call sreed("weight",dim,n,nwin,fwin,jwin,4,weight)
     else
        weight = 1.
     end if
     
     call setuppef(aa,jump,n(1:2),a,known)
     aa%flt=0
     write(0,*)"before estimate:",i3
     write(0,*)"PEF dimensions, value- filter:",size(aa%flt,1),size(aa%flt,2),maxval(aa%flt)
     write(0,*)"lag",aa%lag
     write(0,*)"mis",size(aa%mis),count(aa%mis)
     write(0,*)"pch",size(aa%pch),maxval(aa%pch)
     write(0,*)"niter eps",niter,epsp
     
     call find_pef ( dd, aa, niter, epsp,resd, weight, np)
     write(0,*)"after find:",i3
     
     call setuppef(aa,1/jump,n(1:2),a,alltrue)
     write(0,*)"after estimate:",i3
     write(0,*)"PEF dimensions, value- filter:",size(aa%flt,1),size(aa%flt,2),maxval(aa%flt)
     write(0,*)"lag",aa%lag
     write(0,*)"mis",size(aa%mis),count(aa%mis)
     write(0,*)"pch",size(aa%pch),maxval(aa%pch)
     
     
     write(0,*)"Before filling:",i3
     write(0,*)"data size min max",size(dd),minval(dd),maxval(dd)
     write(0,*)"known size count",size(known),count(known)
     write(0,*)"model size min max",size(model),minval(model),maxval(model)
     write(0,*)"niter, epsf",niter,epsf
     call bn_fill(dd, model, aa, known, niter, epsf)
     call sep_write(model,"out")
!     call srite("out",dim,n,nwin,fwin,jwin,4,model)
     call sep_write(resd,"resd")
!     call srite("resd",dim,n,nwin,fwin,jwin,4,resd)
     
  end do
! end loop here

  call to_history("n1",n(1),residual)
  call to_history("n2",n(2),residual)
  if (dim<3) then
  	call to_history("n3",1,residual)
  else
  	call to_history("n3",n(3),residual)
  end if
  if (dim<4) then
    call to_history("n4",1,residual)
  else
    call to_history("n4",n(4),residual)
  end if
  call sep_close ()
  call exit (0)
end program BNInterp_2d
