module bnhconest  
! Nonstationary convolution, adjoint is the filter.
  use adj_mod
  use bnhelix
  implicit none
  real ,private,  dimension(:), pointer                  :: x 
  type( bnfilter), private :: aa 
  integer, private :: nhmax 
  integer,   private                             :: np 
  contains
  subroutine bnhconest_init ( x_in,aa_in,nhmax_in )
    real ,   dimension(:), pointer                 :: x_in 
    type( bnfilter)    :: aa_in 
    integer    :: nhmax_in 
    x => x_in 
    aa = aa_in 
    nhmax = nhmax_in 
    np = size( aa%flt,1)
  end subroutine
  function bnhconest_lop ( adj, add, a, y) result(stat)
    integer            :: stat 
    logical,intent(in) :: adj,add 
    real,dimension(:)  :: a,y 
    call adjnull (adj,add,a,y )
    call bnhconest_lop2(adj,a,y )
    stat=0
  end function 
  subroutine bnhconest_lop2(adj,a,y)
    logical,intent(in) :: adj 
    real, dimension ( nhmax, np)  :: a 
    real, dimension (:)  :: y 
    integer                        :: ia, ix, iy, ip
    integer, dimension(:), pointer :: lag
    do iy = 1, size( y)
      if ( aa%mis( iy)) then
        cycle
      end if
      ip = aa%pch( iy)
      do ia = 1, size( aa%lag)
        ix = iy - aa%lag( ia)
        if ( ix < 1) then
          cycle
        end if
        if ( adj) then
          a( ia, ip) =    a( ia, ip) +  y( iy) * x( ix)
        else
          y( iy) =         y( iy) +  a( ia, ip) * x( ix)
        end if
      end do
    end do
  end subroutine 
  subroutine bnhconest_close()
  end subroutine 
end module 
