module bnhelicon  
! Nonstationary convolution, inverse to deconvolution.
  use adj_mod
!             Requires the filter be causal with an implicit "1." at the onset.
  use bnhelix
  implicit none
  type( bnfilter), private :: aa 
  contains
  subroutine bnhelicon_init ( aa_in )
    type( bnfilter)    :: aa_in 
    aa = aa_in
  end subroutine
  function bnhelicon_lop ( adj, add, xx, yy) result(stat)
    integer            :: stat 
    logical,intent(in) :: adj,add 
    real,dimension(:)  :: xx,yy 
    call adjnull (adj,add,xx,yy )
    call bnhelicon_lop2(adj,xx,yy )
    stat=0
  end function 
  subroutine bnhelicon_lop2(adj,xx,yy)
    logical,intent(in) :: adj 
    real, dimension (:)  :: xx 
    real, dimension (:)  :: yy 
    integer                         :: iy, ix, ia, ip
    integer, dimension( :), pointer :: lag
    real,    dimension( :), pointer :: flt
    if ( adj) then
! zero lag
      xx =	xx + yy
    else
      yy =	yy + xx
    end if 
    do iy = 1, size( yy)
      if ( associated( aa%mis)) then
        if ( aa%mis( iy)) then
          cycle
        end if
      end if
      ip = aa%pch( iy)
      do ia = 1, size( aa%lag)
        ix = iy - aa%lag( ia)
        if ( ix < 1) then
          cycle
        end if
        if ( adj) then
          xx(ix) =                        xx(ix) + yy(iy) * aa%flt( ia,ip)
        else
          yy(iy) =                        yy(iy) + xx(ix) * aa%flt( ia,ip)
        end if
      end do
    end do
  end subroutine 
  subroutine bnhelicon_close()
  end subroutine 
end module 
