module bnpef_find
! Find non-stationary prediction-error filter (helix magic)
  use bnhconest
  use bnhelix
  use weight
  use laplacf
  use cgstep_mod
  use solver_reg_mod
  use dottest
  implicit none
  contains
  subroutine find_pef( yy, pef, niter, eps, resd, weight,np)
    integer,             intent( in)              :: niter,np(:)
    real,                intent( in)              :: eps	       ! epsilon
    real, dimension( :), pointer                  :: yy, resd, weight,wt
    type( bnfilter)                               :: pef
    integer                                       :: is, ip, ih, nr, nh
    real, allocatable                             :: dd(:),ee(:)
    real, dimension (:), allocatable              :: flt	  
    real, dimension(2) :: dot1,dot2
    nr = size(pef%flt)
    nh = size(pef%lag)
    allocate(flt(nr),dd( size( yy)))
    call bnhconest_init( yy, pef,nh)
    dd=-yy
    call laplacf_init(np,nh)
    call weight_init(weight)
write(0,*)"before solver",np,nh,size(weight)
    call solver_regu(m=flt,d=dd,Fop=bnhconest_lop,Aop=laplacf_lop,Wop=weight_lop,stepper=cgstep,nAop=nr,niter=niter,eps=eps,verb=.false.,resd=resd)
    call cgstep_close()
    call laplacf_close()
    call bnhconest_close()
    do ip = 1, product(np)
      do ih = 1, nh
        pef%flt( ih,ip) = flt( (ip-1)*nh + ih)
      end do
    end do 
    deallocate( flt)
    deallocate(dd)
  end subroutine 
end module 
