module bnpefsetup
! jumps filter lags (for interpolation) and creates new aa%mis based on new lags, data size and mask
  use bnhelix
  use helix
  use regrid
  use helicon
  use cartesian
  implicit none
  contains
    subroutine setuppef(aa,jumpfac,nd,na,known)
      type(bnfilter) :: aa
      real           ::    jumpfac
      integer        ::            nd(:),na(:),stat,iy, my, ib, mb
      logical        ::               known(:)
      type(filter)   ::                      tempfilt
      real, dimension(size(known)):: rr,dfre
      real,    dimension( :), allocatable :: xx, yy
      integer, dimension( size( nd))      :: nb, ii
! scale filter lags on aa
      aa%lag=int(jumpfac*real(aa%lag))
! find where aa is landing on missing data with stationary example
      call allocatehelix(tempfilt,size(aa%lag))
      tempfilt%lag=aa%lag
      
      
      
! find where aa is off the edge of the data
      nb = nd + 2*na
      mb = product( nb)      ! nb is a bigger space to pad into.
      allocate( xx( mb), yy( mb))              ! two large spaces, equal size
      xx = 0.                                  !              zeros
      do ib = 1, mb  
! surround the zeros with many ones
        call line2cart( nb, ib, ii)           ! ii( ib)
        if ( any( ii <= na  .or.  ii > nb-na)) then
          xx( ib) = 1. 
        end if
      end do
      call helicon_init( tempfilt)                   ! give aa pointer to helicon.lop
      call regridn( nd, nb, tempfilt)
      tempfilt%flt = 1.         ! put all 1s in filter  
      stat = helicon_lop( .false., .false., xx, yy)       ! apply filter
      call regridn(   nb, nd, tempfilt)
      tempfilt%flt = 0.  ! remake filter for orig data.
      my = product( nd)
      allocate( tempfilt%mis( my))              ! attach missing designation to y_filter
      do iy = 1, my  
! map from unpadded to padded space
        call line2cart( nd, iy, ii )
        call cart2line( nb,     ii+na, ib )           ! ib( iy)
        aa%mis( iy) =             ( yy( ib) > 0.)    
! true where inputs missing
      end do 
write(0,*)"count of aa% mis mid setuppef",count(aa%mis),size(aa%mis)
      
      
      where(known)
         dfre=0.
      elsewhere
         dfre=1.
      end where
      
      call helicon_init( tempfilt)
      tempfilt%flt = 1.
      stat = helicon_lop( .false., .false., dfre, rr)
      tempfilt%flt = 0. 
      where ( rr > 0.)
        aa%mis = .true.   
      end where

write(0,*)"count of aa% mis post setuppef",count(aa%mis),size(aa%mis)
      deallocate( xx, yy)
    end subroutine
  end module
