module bnsfill
  use  mask1
  use  bnhelicon
  use  cgstep_mod 
  use  solver_mod
  use  solver_reg_mod
  use  solver_smp_mod
  use  random_mod
implicit none
  contains
! fill in missing data by minimizing power out of a given filter.
! by helix magic works in any number of dimensions
  subroutine bn_fill( dd, xx, aa, known, niter,eps )
    integer,                intent( in)     :: niter
    type( bnfilter),         intent( in)     :: aa
    logical, dimension( :), intent( in)     :: known
    real,    dimension( :), intent( in)     :: dd	! fitting variables
    real,    dimension( :), intent( out)    :: xx
    real,    dimension( :), allocatable     :: res, m0
    integer                                 :: nx
    logical, dimension(:), pointer          :: kk
    real                                    :: sigma, eps
    nx = size( xx)
    allocate(m0(nx))
    m0=0.
    where (known)
		xx=dd
		m0=dd
	end where
!    where (.not.known)
!       dd=res
!    elsewhere
!       dd=xx
!    end where
!  data remains fixed
      allocate( kk( nx))
      kk = known
      call mask1_init( kk)
      call bnhelicon_init(aa)
!      call solver_smp( m=xx,d=dd,Fop=bnhelicon_lop,stepper=cgstep,niter=niter,Kop=mask1_lop,m0=m0,verb=.true.)
      call solver_regu(m=xx, d=dd, Fop=mask1_lop, Aop=bnhelicon_lop, nAop=size(dd), stepper=cgstep, niter=niter, eps=eps, verb=.false.)
!      call solver(oper=bnhelicon_lop,solv=cgstep,x=xx,dat=dd,niter=niter,x0=m0,known=kk,verb=.true.)
      call bnhelicon_close()
      call mask1_close()
      deallocate( kk)
    call cgstep_close( )
  end subroutine 
end module 
